ViewVC Help
View File | Revision Log | Show Annotations | Download File
/cvs/deliantra/server/utils/cfutil.in
Revision: 1.83
Committed: Wed Apr 28 20:51:58 2010 UTC (14 years ago) by root
Branch: MAIN
Changes since 1.82: +24 -10 lines
Log Message:
move resource files to arch

File Contents

# Content
1 #!@PERL@
2
3 #
4 # This file is part of Deliantra, the Roguelike Realtime MMORPG.
5 #
6 # Copyright (©) 2007,2008,2009 Marc Alexander Lehmann / Robin Redeker / the Deliantra team
7 #
8 # Deliantra is free software: you can redistribute it and/or modify it under
9 # the terms of the Affero GNU General Public License as published by the
10 # Free Software Foundation, either version 3 of the License, or (at your
11 # option) any later version.
12 #
13 # This program is distributed in the hope that it will be useful,
14 # but WITHOUT ANY WARRANTY; without even the implied warranty of
15 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
16 # GNU General Public License for more details.
17 #
18 # You should have received a copy of the Affero GNU General Public License
19 # and the GNU General Public License along with this program. If not, see
20 # <http://www.gnu.org/licenses/>.
21 #
22 # The authors can be reached via e-mail to <support@deliantra.net>
23 #
24
25 use strict;
26
27 my $prefix = "@prefix@";
28 my $exec_prefix = "@exec_prefix@";
29 my $datarootdir = "@datarootdir@";
30 my $DATADIR = "@datadir@/@PACKAGE@";
31
32 my $CONVERT = "@CONVERT@";
33 #my $IDENTIFY = "@IDENTIFY@";
34 my $OPTIPNG = "@OPTIPNG@";
35 my $RSYNC = "@RSYNC@";
36 my $PNGNQ = "@PNGNQ@";
37
38 use Getopt::Long;
39 use File::Temp;
40 use POSIX ();
41 use Carp;
42
43 use Coro::EV;
44 use AnyEvent;
45 use YAML::XS ();
46 use JSON::XS ();
47 use IO::AIO ();
48 use Digest::MD5 ();
49
50 use Coro 5.12;
51 use Coro::AIO;
52 use Coro::Util;
53 use Coro::Channel;
54 use Coro::Storable; $Storable::canonical = 1;
55
56 use Deliantra;
57
58 $SIG{QUIT} = sub { Carp::cluck "QUIT" };
59
60 sub usage {
61 warn <<EOF;
62 Usage: cfutil [-v] [-q] [--force] [--cache]
63 [--install-arch path]
64 [--install-maps maps]
65 [--print-statedir]
66 [--print-confdir]
67 [--print-datadir]
68 [--print-libdir]
69 [--print-bindir]
70 EOF
71 exit 1;
72 }
73
74 my $VERBOSE = 1;
75 my $CACHE = 0;
76 my $FORCE;
77 my $TMPDIR = "/tmp/cfutil$$~";
78 my $TMPFILE = "aaaa0";
79 my @COMMIT;
80
81 our %COLOR = (
82 black => 0,
83 white => 1,
84 navy => 2,
85 red => 3,
86 orange => 4,
87 blue => 5,
88 darkorange => 6,
89 green => 7,
90 lightgreen => 8,
91 grey => 9,
92 brown => 10,
93 gold => 11,
94 tan => 12,
95 );
96
97 END { system "rm", "-rf", $TMPDIR }
98
99 my $s_INT = EV::signal INT => sub { exit 1 };
100 my $s_TERM = EV::signal TERM => sub { exit 1 };
101
102 our %hash;
103
104 # here we could try to avoid collisions and reduce chksum size further
105 sub make_hash($\$\$;$) {
106 my ($id, $dataref, $hashref, $clen) = @_;
107
108 my $hash = substr +(Digest::MD5::md5 $$dataref), 0, $clen || 4;
109
110 if (exists $hash{$hash}) {
111 # hahs collinion, but some files are simply identical
112 if (${$hash{$hash}[1]} ne $$dataref) {
113 warn "hash collision $hash{$hash}[0] vs. $id\n";
114 exit 1;
115 } else {
116 print "$hash{$hash}[0] and $id are identical (which is fine).\n" if $VERBOSE >= 3;
117 }
118 }
119 $hash{$hash} = [$id, $dataref, $hashref];
120
121 $$hashref = $hash;
122 }
123
124 mkdir $TMPDIR, 0700
125 or die "$TMPDIR: $!";
126
127 sub fork_sub(&) {
128 my ($cb) = @_;
129
130 if (my $pid = fork) {
131 my $current = $Coro::current;
132 my $w = AnyEvent->child (pid => $pid, cb => sub { $current->ready });
133 Coro::schedule;
134 } else {
135 eval { $cb->() };
136 POSIX::_exit 0 unless $@;
137 warn $@;
138 POSIX::_exit 1;
139 }
140 }
141
142 sub inst_maps($) {
143 my (undef, $path) = @_;
144
145 print "\nInstalling '$path' to '$DATADIR/maps'\n\n";
146
147 if (!-f "$path/regions") {
148 warn "'$path' does not look like a maps directory ('regions' file is missing).\n";
149 exit 1 unless $FORCE;
150 }
151
152 system $RSYNC, "-av", "--chmod=u=rwX,go=rX",
153 "$path/.", "$DATADIR/maps/.",
154 "--exclude", "CVS", "--exclude", "/world-precomposed",
155 "--delete", "--delete-excluded"
156 and die "map installation failed.\n";
157
158 print "maps installed successfully.\n";
159 }
160
161 {
162 our %ANIMINFO;
163 our %FACEINFO;
164 our %RESOURCE;
165 our @ARC;
166 our %ARC;
167 our $TRS;
168 our $NFILE;
169 our $PATH;
170
171 our $QUANTIZE = "+dither -colorspace RGB -colors 256";
172
173 our $c_arc = new Coro::Channel;
174 our $c_trs = new Coro::Channel;
175 our $c_res = new Coro::Channel;
176
177 our @c_png;
178
179 sub commit_png($$$) {
180 my ($name, $data, $T) = @_;
181
182 $FACEINFO{$name}{"data$T"} = $data;
183 }
184
185 sub process_png {
186 while (@c_png) {
187 my ($path, $delete) = @{pop @c_png};
188
189 my $png;
190 aio_lstat $path;
191 my ($size, $mtime) = (stat _)[7,9];
192
193 if (0 > aio_load $path, $png) {
194 warn "$path: $!, skipping.\n";
195 next;
196 }
197
198 my $stem = $path;
199 my $T;
200
201 if ($stem =~ s/\.32x32\.png~?$//) {
202 $T = 32;
203 } elsif ($stem =~ s/\.64x64\.png~?$//) {
204 $T = 64;
205 } else {
206 warn "$path: weird filename, skipping.\n";
207 next;
208 }
209
210 # quickly extract width and height of the (necessarily PNG) image
211 unless ($png =~ /^\x89PNG\x0d\x0a\x1a\x0a....IHDR(........)/s) {
212 warn "$path: not a recognized png file, skipping.\n";
213 next;
214 }
215
216 my ($w, $h) = unpack "NN", $1;
217
218 if ($w < $T || $h < $T) {
219 warn "$path: too small ($w $h), skipping.\n";
220 next;
221 }
222
223 if ($w % $T || $h % $T) {
224 warn "$path: weird png size ($w $h), skipping.\n";
225 next;
226 }
227
228 (my $base = $stem) =~ s/^.*\///;
229
230 my $fi = $FACEINFO{$base};
231 unless ($fi) {
232 #warn "$path: <$base> not referenced by any archetype, skipping.\n";
233 #next;
234 }
235
236 my $arc = $fi->{arc} || { };
237
238 unless ($path =~ /~$/) {
239 # possibly enlarge
240 if (0 > aio_stat "$stem.64x64.png") {
241 my $other = "$stem.64x64.png~";
242
243 if (0 > aio_lstat $other or (-M _) > (-M $path)) {
244 fork_sub {
245 my $CROP;
246 my $SRC = "png:\Q$path\E";
247
248 my $is_floor = $arc->{is_floor};
249 my $is_wall = 0;
250
251 my ($wall_pfx, $wall_dir, $wall_sfx);
252
253 if (
254 !$is_floor
255 && !$arc->{alive}
256 && $arc->{move_block} eq "all"
257 && $path =~ /^(.*_)([0-9A-F])(\.x11.*\.png)$/
258 ) {
259 ($wall_pfx, $wall_dir, $wall_sfx) = ($1, hex $2, $3);
260
261 unless (grep { !-e sprintf "%s%X%s", $wall_pfx, $_, $wall_sfx } 0..15) {
262 $is_wall = 1;
263 }
264 }
265
266 if ($is_wall || $is_floor) {
267 # add a 4px border and add other images around it
268 $CROP = "-shave 8x8 +repage";
269
270 $w += 8;
271 $h += 8;
272
273 $SRC = "-size ${w}x${h} xc:transparent";
274 $SRC .= " png:\Q$path\E -geometry +4+4 -composite";
275
276 # 8 surrounding images
277 for (
278 # x y b r0 r1
279 [-1, -1, 0, 6],
280 [ 0, -1, 1, 10, 14],
281 [+1, -1, 0, 12],
282
283 [-1, 0, 8, 5, 7],
284 #
285 [+1, 0, 2, 5, 13],
286
287 [-1, +1, 0, 3],
288 [ 0, +1, 4, 10, 11],
289 [+1, +1, 0, 9],
290 ) {
291 my ($x, $y, $d, $r0, $r1) = @$_;
292
293 my $tile = $is_floor ? $path
294 : $is_wall ? sprintf "%s%X%s", $wall_pfx, ($wall_dir & $d) ? $r1 : $r0, $wall_sfx
295 : die;
296
297 $SRC .= sprintf " png:%s -geometry %+d%+d -composite",
298 "\Q$tile",
299 $x * ($w - 8) + 4,
300 $y * ($h - 8) + 4;
301 }
302 }
303
304 system "convert -depth 8 $SRC rgba:-"
305 . "| $exec_prefix/bin/cfhq2xa $w $h 0"
306 . "| convert -depth 8 -size ".($w * 2)."x".($h * 2)." rgba:- $CROP $QUANTIZE -quality 00 png32:\Q$other\E~"
307 and die "convert/cfhq2xa pipeline error: status $? ($!)";
308 system $OPTIPNG, "-i0", "-q", "$other~";
309 die "$other~ has zero size, aborting." unless -s "$other~";
310 rename "$other~", $other;
311 };
312 }
313
314 push @c_png, [$other, !$CACHE];
315 }
316
317 # possibly scale down
318 if (0 > aio_stat "$stem.32x32.png") {
319 my $other = "$stem.32x32.png~";
320
321 if (0 > aio_lstat $other or (-M _) > (-M $path)) {
322 fork_sub {
323 system "convert png:\Q$path\E -geometry 50% -filter lanczos $QUANTIZE -quality 00 png32:\Q$other\E~";
324 system $OPTIPNG, "-i0", "-q", "$other~";
325
326 # reduce smoothfaces >10000 bytes
327 # obsolete, no longer required
328 if (0 && $stem =~ /_S\./ && (-s "$other~") > 10000) {
329 my $ncolor = 256;
330 while () {
331 system "<\Q$other~\E $PNGNQ -s1 -n$ncolor >\Q$other~~\E";
332 system $OPTIPNG, "-i0", "-q", "$other~~";
333 last if 10000 > -s "$other~~";
334 $ncolor = int $ncolor * 0.9;
335 $ncolor > 8 or die "cannot reduce filesize to < 10000 bytes";
336 }
337
338 printf "reduced %s from %d to %d bytes using %d colours.\n",
339 $other, -s "$other~", -s "$other~~", $ncolor
340 if $VERBOSE >= 2;
341 rename "$other~~", "$other~";
342 }
343
344 die "$other~ has zero size, aborting." unless -s "$other~";
345 rename "$other~", $other;
346 };
347 }
348
349 #warn "scaled down $path to $other\n";#d#
350 push @c_png, [$other, !$CACHE];
351 }
352 }
353
354 (my $face = $stem) =~ s/^.*\///;
355
356 # split all bigfaces, but avoid smoothfaces (*_S)
357 if (($w > $T || $h > $T) && $face !~ /_S\./) {
358 # split
359 my @tile;
360 for my $x (0 .. (int $w / $T) - 1) {
361 for my $y (0 .. (int $h / $T) - 1) {
362 my $file = "$path+$x+$y~";
363 aio_lstat $file;
364 push @tile, [$x, $y, $file, (stat _)[9]];
365 }
366 }
367
368 my $mtime = (lstat $path)[9];
369 my @todo = grep { $_->[3] <= $mtime } @tile;
370 if (@todo) {
371 fork_sub {
372 open my $convert, "|-", $CONVERT,
373 "png:-",
374 (map {
375 (
376 "(",
377 "+clone",
378 -crop => (sprintf "%dx%d+%d+%d", $T, $T, $_->[0] * $T, $_->[1] * $T),
379 "+repage",
380 -quality => "00",
381 -write => "png32:$_->[2]~",
382 "+delete",
383 ")",
384 )
385 } @todo),
386 "null:";
387
388 binmode $convert;
389 print $convert $png;
390 close $convert;
391
392 # pass 2, optimise, and rename
393 for (@todo) {
394 system $OPTIPNG, "-o5", "-i0", "-q", "$_->[2]~";
395 die "$_->[2]~ has zero size, aborting." unless -s "$_->[2]~";
396 rename "$_->[2]~", $_->[2];
397 }
398 };
399 }
400
401 for (@tile) {
402 my ($x, $y, $file) = @$_;
403 my $tile;
404
405 if (0 > aio_load $file, $tile) {
406 die "$path: unable to read tile +$x+$y, aborting.\n";
407 }
408 IO::AIO::aio_unlink $file unless $CACHE;
409 commit_png $x|$y ? "$face+$x+$y" : $face, $tile, $T;
410 }
411 } else {
412 # use as-is (either small, use smooth)
413 commit_png $face, $png, $T;
414 }
415
416 aio_unlink $path if $delete;
417 }
418 }
419
420 sub process_arc {
421 while (my $job = $c_arc->get) {
422 my ($dir, $file) = @$job;
423
424 my $arc;
425 aio_load "$dir/$file", $arc; # simply pre-cache, as read_arch wants a file :/
426
427 my $arc = read_arch "$dir/$file";
428 for my $o (values %$arc) {
429 push @ARC, $o;
430 for (my $m = $o; $m; $m = $m->{more}) {
431 $ARC{$m->{_name}} = $m;
432 }
433
434 $o->{editor_folder} ||= "\x00$dir"; # horrible kludge
435
436 my $visibility = delete $o->{visibility};
437 my $magicmap = delete $o->{magicmap};
438
439 # find upper left corner :/
440 # omg, this is sooo broken
441 my ($dx, $dy);
442 for (my $o = $o; $o; $o = $o->{more}) {
443 $dx = $o->{x} if $o->{x} < $dx;
444 $dy = $o->{y} if $o->{y} < $dy;
445 }
446
447 for (my $o = $o; $o; $o = $o->{more}) {
448 my $x = $o->{x} - $dx;
449 my $y = $o->{y} - $dy;
450
451 my $ext = $x|$y ? "+$x+$y" : "";
452
453 $o->{face} .= $ext unless /^blank.x11$|^empty.x11$/ || !$o->{face};
454
455 $visibility = delete $o->{visibility} if exists $o->{visibility};
456 $magicmap = delete $o->{magicmap} if exists $o->{magicmap};
457
458 my $anim = delete $o->{anim};
459
460 if ($anim) {
461 # possibly add $ext to the animation name to avoid
462 # the need to specify archnames for all parts
463 # of a multipart archetype.
464 $o->{animation} = "$o->{_name}";
465 my $facings = 1;
466 my @frames;
467
468 for (@$anim) {
469 if (/^facings\s+(\d+)/) {
470 $facings = $1*1;
471 } elsif (/^blank.x11$|^empty.x11$/) {
472 push @frames, $_;
473 } else {
474 push @frames, "$_$ext";
475 }
476 }
477
478 $ANIMINFO{$o->{animation}} = {
479 facings => $facings,
480 frames => \@frames,
481 };
482 }
483
484 for ($o->{face} || (), @{$anim || []}) {
485 next if /^facings\s/;
486
487 my $face = $_;
488 $face =~ s/\+\d+\+\d+$//; # remove tile offset coordinates
489
490 my $info = $FACEINFO{$face} ||= { };
491 $info->{arc} = $o;
492
493 next if $face =~ /^blank.x11$|^empty.x11$/;
494
495 $info->{visibility} = $visibility if defined $visibility;
496 $info->{magicmap} = $magicmap if defined $magicmap;
497 }
498
499 if (my $smooth = delete $o->{smoothface}) {
500 my %kv = split /\s+/, $smooth;
501 my $level = $o->{smoothlevel}; #TODO: delete from $o if !gcfclient-support
502 while (my ($face, $smooth) = each %kv) {
503 $FACEINFO{$smooth}{arc} = $o;
504
505 $FACEINFO{$face}{smooth} = $smooth;
506 $FACEINFO{$face}{smoothlevel} = $level;
507 }
508 }
509 }
510 }
511 }
512 }
513
514 sub process_trs {
515 while (my $job = $c_trs->get) {
516 my ($dir, $file) = @$job;
517 my $path = "$dir/$file";
518
519 my $trs;
520 if (0 > aio_load $path, $trs) {
521 warn "$path: $!, skipping.\n";
522 next;
523 }
524
525 $TRS .= $trs;
526 }
527 }
528
529 my %FILECACHE;
530
531 sub load_cached($;$) {
532 unless (exists $FILECACHE{$_[0]}) {
533 my $data;
534 if (0 < aio_load $_[0], $data) {
535 if ($_[1]) {
536 $data = eval { $_[1]->($data) };
537 warn "$_[0]: $@" if $@;
538 }
539 }
540
541 $FILECACHE{$_[0]} = $data;
542 }
543
544 $FILECACHE{$_[0]}
545 }
546
547 sub process_res {
548 while (my $job = $c_res->get) {
549 my ($dir, $file, $type) = @$job;
550
551 my $data;
552 aio_load "$dir/$file", $data;
553
554 my $meta = load_cached "$dir/meta", sub { JSON::XS->new->utf8->relaxed->decode (shift) };
555
556 utf8::decode $dir;
557 utf8::decode $file;
558
559 # a meta file for resources is now mandatory
560 unless (exists $meta->{$file}) {
561 warn "skipping $dir/$file\n" if $VERBOSE >= 3;
562 next;
563 }
564
565 $meta = {
566 %{ $meta->{"" } || {} },
567 %{ $meta->{$file} || {} },
568 };
569
570 if ($meta->{license} =~ s/^#//) {
571 $meta->{license} = ({
572 "pd" => "Public Domain",
573 "gpl" => "GNU General Public License, version 3.0 or any later",
574 "cc/by/2.0" => "Licensed under Creative Commons Attribution 2.0 http://creativecommons.org/licenses/by/2.0/",
575 "cc/by/2.5" => "Licensed under Creative Commons Attribution 2.5 http://creativecommons.org/licenses/by/2.5/",
576 "cc/by/3.0" => "Licensed under Creative Commons Attribution 3.0 http://creativecommons.org/licenses/by/3.0/",
577 })->{$meta->{license}}
578 || warn "$dir/$file: license tag '$meta->{license}' not found.";
579 }
580
581 $file =~ s/\.res$//;
582 $file =~ s/\.(ogg|wav|jpg|png)$//;
583
584 substr $dir, 0, 1 + length $PATH, "";
585
586 if (my $filter = $meta->{cfutil_filter}) {
587 if ($filter eq "yaml2json") {
588 $data = JSON::XS::encode_json YAML::XS::Load $data;
589 } elsif ($filter eq "json2json") {
590 $data = JSON::XS::encode_json JSON::XS->relaxed->utf8->decode ($data);
591 } elsif ($filter eq "perl2json") {
592 $data = eval $data; die if $@;
593 $data = JSON::XS::encode_json $data;
594 } else {
595 warn "$dir/$file: unknown filter $filter, skipping\n";
596 }
597 }
598
599 $RESOURCE{"$dir/$file"} = {
600 type => (exists $meta->{type} ? delete $meta->{type} : $type),
601 data => $data,
602 %$meta ? (meta => $meta) : (),
603 };
604 }
605 }
606
607 sub find_files;
608 sub find_files {
609 my ($path) = @_;
610
611 IO::AIO::aioreq_pri 4;
612 IO::AIO::aio_scandir $path, 4, sub {
613 my ($dirs, $nondirs) = @_;
614
615 find_files "$path/$_"
616 for grep $_ !~ /^(?:CVS|dev|\..*)$/, @$dirs;
617
618 my $dir = $path;
619 substr $dir, 0, 1 + length $PATH, "";
620
621 for my $file (@$nondirs) {
622 if ($dir =~ /^music(?:\/|$)/) {
623 $c_res->put ([$path, $file, 3]) # FT_MUSIC
624 if $file =~ /\.(ogg)$/;
625
626 } elsif ($dir =~ /^sound(?:\/|$)/) {
627 $c_res->put ([$path, $file, 5]) # FT_SOUND
628 if $file =~ /\.(wav|ogg)$/;
629
630 } elsif ($dir =~ /^res(?:\/|$)/) {
631 if ($file =~ /\.(jpg|png)$/) {
632 $c_res->put ([$path, $file, 0]) # FT_FACE
633 } elsif ($file =~ /\.(res)$/) {
634 $c_res->put ([$path, $file, 6]) # FT_RSRC
635 } else {
636 $c_res->put ([$path, $file, undef]);
637 }
638
639 } elsif ($file =~ /\.png$/) {
640 push @c_png, ["$path/$file", 0];
641
642 } elsif ($file =~ /\.trs$/) {
643 $c_trs->put ([$path, $file]);
644
645 } elsif ($file =~ /\.arc$/) {
646 $c_arc->put ([$path, $file]);
647
648 } else {
649 warn "ignoring $path/$file\n" if $VERBOSE >= 3;
650 }
651 }
652 };
653 }
654
655 sub generate_plurals {
656 # use Lingua::EN::Inflect ();
657 # Lingua::EN::Inflect::classical;
658 # Lingua::EN::Inflect::def_noun '(.*)staff' => '$1staves'; # policy
659 # Lingua::EN::Inflect::def_noun '(.*)boots' => '$1boots'; # hack
660 #
661 # for my $a (@ARC) {
662 # my $name = $a->{name} || $a->{_name};
663 #
664 # next unless $a->{name_pl};
665 # next if $a->{invisible};
666 # next if $a->{is_floor};
667 # next if $a->{no_pick};
668 #
669 # my $test = Lingua::EN::Inflect::PL_N_eq $name, Lingua::EN::Inflect::PL $name;
670 # my $pl = $test =~ /^(?:eq|p:.)$/
671 # ? $name
672 # : Lingua::EN::Inflect::PL $name;
673 #
674 # if ($pl ne $a->{name_pl}) {
675 # warn "$a->{_name}: plural differs, $pl vs $a->{name_pl}\n";
676 # }
677 # }
678 }
679
680 sub inst_arch($) {
681 my (undef, $path) = @_;
682
683 $PATH = $path;
684
685 print "\n",
686 "Installing '$path' to '$DATADIR'\n",
687 "\n",
688 "This can take a long time if you run this\n",
689 "for the first time or do not use --cache.\n",
690 "\n",
691 "Unless you run verbosely, all following warning\n",
692 "or error messages indicate serious problems.\n",
693 "\n";
694
695 if (!-d "$path/treasures") {
696 warn "'$path' does not look like an arch directory ('treasures' directory is missing).\n";
697 exit 1 unless $FORCE;
698 }
699
700 print "scanning files...\n" if $VERBOSE;
701
702 find_files $path;
703
704 my @a_arc = map +(async \&process_arc), 1..2;
705 my @a_res = map +(async \&process_res), 1..2;
706 my @a_trs = map +(async \&process_trs), 1..2;
707
708 IO::AIO::flush;
709
710 $c_res->shutdown;
711 $c_arc->shutdown;
712 $c_trs->shutdown;
713
714 print "start file scan, arc, res processing...\n" if $VERBOSE;
715
716 $_->join for @a_arc; # need to parse all archetypes before png processing
717
718 print "end arc, start png processing...\n" if $VERBOSE;
719
720 # eight png crunchers work fine for my 4x smp machine
721 my @a_png = map +(async \&process_png), 1..8;
722
723 $_->join for (@a_trs, @a_res, @a_png);
724
725 print "scanning done, processing results...\n" if $VERBOSE;
726 {
727 # remove path prefix from editor_folder
728 $_->{editor_folder} =~ /^\x00/
729 and substr $_->{editor_folder}, 0, 2 + length $path, ""
730 for values %ARC;
731
732 print "resolving inheritance tree...\n" if $VERBOSE;
733 # resolve inherit
734 while () {
735 my $progress;
736 my $loop;
737
738 for my $o (values %ARC) {
739 for my $other (split /,/, $o->{inherit}) {
740 if (my $s = $ARC{$other}) {
741 if ($s->{inherit}) {
742 $loop = $s;
743 } else {
744 delete $o->{inherit};
745 my %s = %$s;
746 delete @s{qw(_name more name name_pl)};
747 %$o = ( %s, %$o );
748 ++$progress;
749 }
750 } else {
751 warn "'$o->{_name}' tries to inherit from undefined archetype '$other', skipping.\n";
752 delete $ARC{$o->{_name}};
753 }
754 }
755 }
756
757 unless ($progress) {
758 die "inheritance loop detected starting at archetype '$loop->{_name}', aborting.\n"
759 if $loop;
760
761 last;
762 }
763 }
764
765 # remove base classes (by naming scheme, should use something like "baseclass xxx" to inherit
766 @ARC = grep $_->{_name} !~ /^(?:type|class)_/, @ARC;
767
768 print "generating plurals...\n" if $VERBOSE;
769 generate_plurals;
770
771 printf "writing %d archetypes...\n", scalar @ARC if $VERBOSE;
772 open my $fh, ">:utf8", "$DATADIR/archetypes~"
773 or die "$DATADIR/archetypes~: $!";
774 print $fh Deliantra::archlist_to_string [sort { $a->{_name} cmp $b->{_name} } @ARC];
775 }
776
777 {
778 printf "writing treasures (%d octets)...\n", length $TRS if $VERBOSE;
779 open my $fh, ">:utf8", "$DATADIR/treasures~"
780 or die "$DATADIR/treasures~: $!";
781 print $fh $TRS;
782 }
783
784 {
785 print "processing facedata...\n" if $VERBOSE;
786 while (my ($k, $v) = each %FACEINFO) {
787 length $v->{data32} or warn "$k: face has no png32. this will not work (shoddy gcfclient will crash of course).\n";
788 length $v->{data64} or warn "$k: face has no png64. this will not work very well.\n";
789
790 make_hash $k, $v->{data32}, $v->{hash32};
791 make_hash $k, $v->{data64}, $v->{hash64};
792
793 #length $v->{data32} <= 10000 or warn "$k: face32 larger than 10000 bytes, will not work with crossfire client.\n";
794 #length $v->{data64} <= 10000 or warn "$k: face64 larger than 10000 bytes.\n";
795
796 if (my $magicmap = $v->{magicmap}) {
797 $magicmap =~ y/A-Z_\-/a-z/d;
798 $v->{magicmap} = $COLOR{$magicmap};
799 }
800
801 delete $v->{arc};
802 }
803
804 print "processing resources...\n" if $VERBOSE;
805 my $enc = JSON::XS->new->utf8->canonical->relaxed;
806 while (my ($k, $v) = each %RESOURCE) {
807
808 if ($v->{meta} && $v->{meta}{datadir}) {
809 delete $RESOURCE{$k};
810
811 $k =~ s/^res\/// or die "$k: datadir files must be in res/";
812
813 printf "writing $k (%d octets)...\n", length $v->{data} if $VERBOSE;
814 open my $fh, ">:raw", "$DATADIR/$k~"
815 or die "$DATADIR/$k~: $!";
816 syswrite $fh, $v->{data};
817 push @COMMIT, $k;
818
819 } else {
820 if ($v->{type} & 1) {
821 # prepend meta info
822
823 my $meta = $enc->encode ({
824 name => $k,
825 %{ $v->{meta} || {} },
826 });
827
828 $v->{data} = pack "(w/a*)*", $meta, $v->{data};
829 }
830
831 make_hash $k, $v->{data}, $v->{hash}, 6; # 6 for the benefit of existing clients
832 }
833 }
834
835 printf "writing facedata (%d faces, %d anims, %d resources)...\n",
836 scalar keys %FACEINFO,
837 scalar keys %ANIMINFO,
838 scalar keys %RESOURCE
839 if $VERBOSE;
840
841 open my $fh, ">:perlio", "$DATADIR/facedata~"
842 or die "$DATADIR/facedata~: $!";
843
844 print $fh nfreeze {
845 version => 2,
846 faceinfo => \%FACEINFO,
847 animinfo => \%ANIMINFO,
848 resource => \%RESOURCE,
849 };
850
851 }
852
853 print "committing files...\n" if $VERBOSE;
854
855 for (qw(archetypes facedata treasures), @COMMIT) {
856 chmod 0644, "$DATADIR/$_~";
857 rename "$DATADIR/$_~", "$DATADIR/$_"
858 or die "$DATADIR/$_: $!";
859 }
860
861 print "archetype data installed successfully.\n";
862 }
863 }
864
865 Getopt::Long::Configure ("bundling", "no_ignore_case");
866 GetOptions (
867 "verbose|v:+" => \$VERBOSE,
868 "cache" => \$CACHE,
869 "quiet|q" => sub { $VERBOSE = 0 },
870 "force" => sub { $FORCE = 1 },
871 "install-arch=s" => \&inst_arch,
872 "install-maps=s" => \&inst_maps,
873 "print-statedir" => sub { print "@pkgstatedir@\n" },
874 "print-datadir" => sub { print "$DATADIR\n" },
875 "print-confdir" => sub { print "@pkgconfdir@\n" },
876 "print-libdir" => sub { print "@libdir@/@PACKAGE@\n" },
877 "print-bindir" => sub { print "@bindir@/@PACKAGE@\n" },
878 ) or usage;
879